<?php
################################################################################
# @Name : /plugins/mailtoservice/mail2ticket.php
# @Description : plugin add
# @Call : /plugin.php
# @Parameters : 
# @Author : Flox
# @Create : 30/04/2024
# @Update : 30/04/2024
# @Version : 1.3
################################################################################

$merge = array();
foreach ($mailboxes as $mailbox)
{
	if($cmd) {
		echo 'MAILBOX : '.$mailbox.PHP_EOL;
	} else {
		echo 'MAILBOX : <span style="color:green">'.$mailbox.'</span><br />';
	}
	ob_start();
	if($rparameters['imap_auth_type']=='oauth_azure' || $rparameters['imap_auth_type']=='login2' || $rparameters['imap_auth_type']=='oauth_google') 
	{
		//Webklex/php-imap
		require(__DIR__ . '/../../core/imap_oauth.php');
	} else { //basic auth
		//php-imap/php-imap
		require(__DIR__ . '/../../core/imap_basic.php');
	}
	
	$dump = ob_get_contents();
	if($rparameters['debug']) {echo 'DEBUG : dump'.print_r($dump);}

	//ob_end_clean();
	preg_match_all('/\(([0-9]+)\)/',$dump,$output);
	if(count($output[1])> 0) {
		$merge = array_merge($merge,$output[1]);
	}

	sleep(1); //timeout 1 seconds to limit network trafic
}

if($rparameters['debug']) {echo 'DEBUG : merge'.print_r($merge);}

//disconnect from mailbox  #6063
if(isset($con_mailbox)) {$con_mailbox->disconnect();}

$rpims = array();

$qry=$db->prepare("SELECT * FROM `tplugins_mail_router`");
$qry->execute();
while($row=$qry->fetch()) 
{
	$rpims[] = $row;
}
$qry->closeCursor();

$results = array_unique($merge);

foreach($results as $id )
{
	$id = (int) $id;
	$qry=$db->prepare("SELECT `id`,`title` FROM `tincidents` WHERE `id`=:id");
	$qry->execute(array(
		'id' => $id
	));
	$row=$qry->fetch();
	$qry->closeCursor();

	foreach($rpims as $rpim)
	{
		if(strpos($row['title'],$rpim['subject_tag']) !== false)
		{
			$qry_update=$db->prepare("UPDATE `tincidents` SET `u_service`=:service_id,`category`=:category,`subcat`=:subcat WHERE `id`=:id");
			$qry_update->execute(array(
				'id' => $id,
				'service_id' => htmlspecialchars($rpim['service_id'], ENT_QUOTES, 'UTF-8'),
				'category' => htmlspecialchars($rpim['category'], ENT_QUOTES, 'UTF-8'),
				'subcat' => htmlspecialchars($rpim['subcat'], ENT_QUOTES, 'UTF-8')
			));
		}
	}
	
}

if($cmd) {
	echo 'Total '.$count.' mails received in '.round(microtime(true) - $start).' sec.'.PHP_EOL;
	echo PHP_EOL;
} else {
	echo 'Total '.$count.' mails received in '.round(microtime(true) - $start).' sec.<br />';			
}

exit;
?>